<?php

namespace Drupal\group_notify\Plugin;

use Drupal\gnode\Plugin\GroupContentEnabler\GroupNode;
use Drupal\Core\Form\FormStateInterface;

class NotifyGroupNode extends GroupNode {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);

    $form['notify'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Notify group members'),
      '#description' => $this->t('Send an email when group content is added.'),
      '#default_value' => $this->configuration['notify'] ?? FALSE
    ];

    $form['options'] = [
      '#type' => 'fieldset',
      '#title' => $this->t('Notification mode'),
      '#states' => ['visible' => [':input[name="notify"]' => ['checked' => TRUE]]]
    ];

    $form['options']['notify_mode'] = [
      '#type' => 'radios',
      '#default_value' => $this->configuration['notify_mode'] ?? 'enforce',
      '#options' => [
        'enforce' => $this->t('Enforced: Always send notification.'),
        'toggle' => $this->t('Toggled: Optionally turn on/off notifications for select posts.')
      ]
    ];

    return $form;
  }

}

